#include <stdio.h>
#include <string.h>

#define MAXLEN 256

int main(int argc, char *argv[]) {
    char line[MAXLEN];

	/*
	 * wenn nicht genau ein Kommando-Zeilen-Argument,
	 * dann "Usage-Meldung" auf stderr ausgeben => Konvention!!!
	 */
    if (argc != 2) {
	fprintf(stderr, "Usage: %s pattern\n", argv[0]);
	return 1;
    }
    
	/* bei EOF oder Fehler liefert fgets() NULL! */
    while (fgets(line, MAXLEN, stdin))
	if (strstr(line, argv[1]))	/* enthaelt line den String argv[1] als Teilstring? */
	    fputs(line, stdout);

    return 0;
}
