#include <stdio.h>
#include <stdlib.h>

int main() {
    int len;
    char *s;

    /* Groesse des Arrays von stdin lesen */
    scanf("%d\n", &len);

    /* Array allokieren mit Fehlerbehandlung */
    if ((s = calloc(sizeof(char), len)) == NULL) {
	fprintf(stderr, "error: no more memory available\n");
	return 1;
    }

    /* Zeile von stdin in neuen String einlesen ... */
    fgets(s, len, stdin);

    /* ... und gleich wieder ausgeben */
    printf("Eingabe: \"%s\"\n", s);

    /* Speicherplatz wieder freigeben */
    free(s);
    s = NULL;	/* => zur Sicherheit => kein Zugriff mehr mgl.! */

    return 0;
}
