#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main() {
	char *s1 = "Hallo Welt!";
	char *s2 = "Also dann viel Spass ... :-)";
	char *s;

	    /*
	     * erst mal Speicherplatz fuer eine Kopie von s1 besorgen
	     * (der type cast (char*) ist nicht notwendig, aber sprechender!)
	     */
	s = (char*) calloc(sizeof(char), strlen(s1)+1);
	strcpy(s, s1);

	puts(s);

	    /*
	     * ... nun wollen wir die Groesse des allokierten
	     * Speicherplatzes veraendern (egal, ob groesser oder kleiner!)
	     * WICHTIG: Dabei kann sich die Position des allokierten
	     * Speicherplatzes aendern! Die evtl. veraenderte Position liefert
	     * realloc() als Rueckgabewert. Deshalb ist so wichitg, dass s der
	     * Rueckgabewert von realloc() wieder zugewiesen wird.
	     * (Nur etwas problematisch bei Speicherallokationsfehler!)
	     */
	s = (char*) realloc(s, sizeof(char)*(strlen(s2)+1));
	strcpy(s, s2);

	puts(s);

	return 0;
}
